local function skin_Blizzard_QuestChoice()
	
	local function miirui_QuestChoiceFrame_Update()
		WarboardQuestChoiceFrame.CloseButton.Border:Hide()
		WarboardQuestChoiceFrame.Background.BackgroundTile:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock.blp")
		WarboardQuestChoiceFrame.NineSlice.TopLeftCorner:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.LeftEdge:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.BottomLeftCorner:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.TopRightCorner:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.RightEdge:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.BottomRightCorner:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.TopEdge:SetAlpha(0)
		WarboardQuestChoiceFrame.NineSlice.BottomEdge:SetAlpha(0)
		local _, _, numOptions = GetQuestChoiceInfo();
		if numOptions == 4 then
			for i=1, numOptions do
				local option = WarboardQuestChoiceFrame["Option"..i];
				option.ArtworkBorder:ClearAllPoints()
				option.ArtworkBorder:SetPoint("TOP",option,0.5,0.5)
				m_fontify(option.OptionText,"white")
				m_fontify(option.Header.Text,"color")
				if option.Header.Icon then 
					option.Header.Icon:Hide()
				end
			end
		elseif numOptions == 2 then
			for i=1, numOptions do
				local option = WarboardQuestChoiceFrame["Option"..i];
				option.ArtworkBorder:ClearAllPoints()
				option.ArtworkBorder:SetPoint("TOP",option,0,0)
				m_fontify(option.OptionText,"white")
				m_fontify(option.Header.Text,"color")
				if option.Header.Icon then 
					option.Header.Icon:Hide()
				end
			end
		elseif numOptions == 3 then
			for i=1, numOptions do
				local option = WarboardQuestChoiceFrame["Option"..i];
				option.ArtworkBorder:ClearAllPoints()
				option.ArtworkBorder:SetPoint("TOP",option,0.5,0.5)
				m_fontify(option.OptionText,"white")
				m_fontify(option.Header.Text,"color")
				if option.Header.Icon then 
					option.Header.Icon:Hide()
				end
			end
		elseif numOptions == 5 then
			for i=1, numOptions do
					local option = WarboardQuestChoiceFrame["Option"..i];
					if option then
						option.ArtworkBorder:ClearAllPoints()
						option.ArtworkBorder:SetPoint("TOP",option,0.5,0.5)
						m_fontify(option.OptionText,"white")
						m_fontify(option.Header.Text,"color")
						if option.Header.Icon then 
							option.Header.Icon:Hide()
						end
					end
			end
		elseif numOptions == 1 then
			for i=1, numOptions do
				local option = WarboardQuestChoiceFrame["Option"..i];
				m_fontify(option.OptionText,"white")
				m_fontify(option.Header.Text,"color")
				if option.Header.Icon then 
					option.Header.Icon:Hide()
				end
			end
		end

		
	end

	hooksecurefunc(WarboardQuestChoiceFrame,"Update",miirui_QuestChoiceFrame_Update)
	
	hooksecurefunc(UIWidgetBaseColoredTextMixin,"SetEnabledState",function(self)
		m_fontify(self,"white")
	end)

	hooksecurefunc(UIWidgetTemplateStatusBarMixin,"Setup",function(self)
		self.Bar.BorderLeft:Hide()
		self.Bar.BorderRight:Hide()
		self.Bar.BorderCenter:Hide()
		self.Bar.border = CreateFrame("Frame", nil, self.Bar)
		self.Bar.border:SetPoint("TOPLEFT", self.Bar, "TOPLEFT", -4, 4)
		self.Bar.border:SetPoint("BOTTOMRIGHT", self.Bar, "BOTTOMRIGHT", 4, -4)
		self.Bar.border:SetBackdrop({
		bgFile = "", 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = true, tileSize = 16, edgeSize = 14, 
		insets = { left = -20, right =-20, top = 10, bottom = -10 }});
		self.Bar.border:SetFrameLevel(self.Bar:GetFrameLevel())
		self.Bar.BGLeft:Hide()
		self.Bar.BGRight:Hide()
		self.Bar.BGCenter:Hide()
	end)

	WarboardQuestChoiceFrame:HookScript("OnSizeChanged",function(self)
		if WarboardQuestChoiceFrame.Option1 then
			local self=WarboardQuestChoiceFrame.Option1.WidgetContainer
			if self:GetNumChildren() == 2 then
				local _,textframe=self:GetChildren()
				if textframe.Text then
					m_fontify(textframe.Text,"white")
				end
				if textframe.LeadingText then
					m_fontify(textframe.LeadingText,"white")
				end
			end
		end
		if WarboardQuestChoiceFrame.Option2	then
		local self=WarboardQuestChoiceFrame.Option2.WidgetContainer
			if self:GetNumChildren() == 2 then
				local _,textframe=self:GetChildren()
				if textframe.Text then
					m_fontify(textframe.Text,"white")
				end
				if textframe.LeadingText then
					m_fontify(textframe.LeadingText,"white")
				end
			end
		end
	end)
	
	m_border(WarboardQuestChoiceFrame,826,602,"CENTER",0,0,12,"TOOLTIP")
	m_border_WarboardQuestChoiceFrame:SetPoint("TOPLEFT",WarboardQuestChoiceFrame,-2,2.5)
	m_border_WarboardQuestChoiceFrame:SetPoint("BOTTOMRIGHT",WarboardQuestChoiceFrame,0,-1.5)
	
	
end

local catchaddon = CreateFrame("FRAME")
catchaddon:RegisterEvent("ADDON_LOADED")

--function to catch loading addons
local function skinnedOnLoad(_, _, addon)
	if addon == "Blizzard_WarboardUI" then
		skin_Blizzard_QuestChoice()
	end
end

--this function decides whether the addon is already loaded or if we need to look out for it!

local function skinnedOnLogin()
	if IsAddOnLoaded("Blizzard_WarboardUI") then
		-- Addon is already loaded, procceed to skin!
		skin_Blizzard_QuestChoice()
	else
		-- Addon is not loaded yet, procceed to look out for it!
		catchaddon:SetScript("OnEvent", skinnedOnLoad)
	end
end

local HelloWorld = CreateFrame("FRAME")
HelloWorld:RegisterEvent("PLAYER_ENTERING_WORLD")
HelloWorld:SetScript("OnEvent", skinnedOnLogin)